package com.ruoyi.common.utils;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.ruoyi.common.utils.sql.SqlUtil;
import com.ruoyi.framework.web.page.PageDomain;
import com.ruoyi.framework.web.page.TableSupport;

import java.util.List;

/**
 * 分页工具类
 * 
 * @author ruoyi
 */
public class PageUtils extends PageHelper
{
    /**
     * 设置请求分页数据
     */
    public static void startPage()
    {
        PageDomain pageDomain = TableSupport.buildPageRequest();
        Integer pageNum = pageDomain.getPageNum();
        Integer pageSize = pageDomain.getPageSize();
        String orderBy = SqlUtil.escapeOrderBySql(pageDomain.getOrderBy());
        Boolean reasonable = pageDomain.getReasonable();
        PageHelper.startPage(pageNum, pageSize, orderBy).setReasonable(reasonable).setPageSizeZero(true);
    }

    /**
     * 清理分页的线程变量
     */
    public static void clearPage()
    {
        PageHelper.clearPage();
    }


    /**
     * 复制分页信息，如果存在的话
     * 
     * @param list  数据列表
     * @param collect   结果集
     * @return  结果集
     */
    public static <T, R> List<R> copyPageIfPresent(List<T> list, List<R> collect) {
        if (list instanceof Page) {
            Page<T> page = (Page<T>) list;
            // Page<R> pageR = (Page<R>) collect;
            try (Page<R> pageR = new Page<>();) {
                pageR.setTotal(page.getTotal());
                pageR.setPageNum(page.getPageNum());
                pageR.setPageSize(page.getPageSize());
                pageR.setPages(page.getPages());
                pageR.addAll(collect);
                return pageR;
            }
        }
        return collect;
    }
}
